#pragma once

#include <vector>
#include <J3ML/LinearAlgebra/Common.h>
#include <J3ML/Geometry/Common.h>
#include <J3ML/J3ML.h>


using namespace J3ML::LinearAlgebra;

namespace J3ML::Geometry
{

    class TriangleMesh
    {
    public:
        /// Default constructor for a triangle mesh.
        TriangleMesh(int expectedPolygonCount = 1000);

    public:
        //std::vector<Vector3> Vertices;
        //std::vector<Vector3> Normals;
        //std::vector<Vector3> UVs;
        //std::vector<u64> Indices;

        std::vector<float> GenerateVertexList();
        //std::vector<Triangle> GenerateTriangleList();
    private:
        std::vector<float> cachedVertexList;
        //std::vector<Triangle> cachedTriangleList;
    };

}